DECLARE SUB GETNUM (PA!)
DECLARE SUB GETSTRG (PA$)

REM DIAMETER WEIGHT v1.23
REM 28 APRIL 2004
REM USING DIAMETER INDEX

DIM TYP$(16)
DATA 1A, 1B, 1C, 1D, 1E, 1F, 1G, 2L, 2, 2M, 3, 3D, 4, 4M, 4H, 5
FOR I = 1 TO 16
  READ TYP$(I)
NEXT I

DATA 0.78, 1.56, 3.125, 6.25, 12.5, 25, 50, 100, 200, 400, 800, 1600, 3200, 6400, 12800, 25600

EXPAN = 1.71
BP = 1.5
VEL0 = 2300
PRHYP$ = "R"
DIAMIN = .224

CLS
PRINT " DIAMETER WEIGHT v1.23"
PRINT " 28 APRIL 2004"
PRINT " CALCULATES VALUES FOR *.CHK FILES, USING DIAMETER WEIGHT INDEX"

PRINT
PRINT "ENTER BULLET PROPORTION ";
CALL GETNUM(BP)

PRINT
PRINT "ENTER RIFLE/PISTOL (R/P)";
CALL GETSTRG(PRHYP$)

PRINT
PRINT "ENTER EXPANSION FACTOR ";
CALL GETNUM(EXPAN)

PRINT
PRINT "ENTER VELOCITY ";
CALL GETNUM(VEL0)
PRINT

PRINT "BULLET", "BULLET", "GAME", "GAME", "OGW"
PRINT "DIA", "WEIGHT", "WEIGHT", "GUIDE", "WEIGHT"
PRINT "INCH", "GRAIN", "LB", "INDEX", "LB"

OPEN "DW.TXT" FOR OUTPUT AS #1
PRINT #1, "BULLET EXPANSION ="; EXPAN
PRINT #1, "BULLET PROPORTION ="; BP;
IF PRHYP$ = "R" OR PRHYP$ = "r" THEN
  PRHYP2$ = "RIFLE"
ELSE
  PRHYP2$ = "PISTOL"
END IF
PRINT #1, ", "; PRHYP2$
PRINT #1, "VELOCITY =";VEL0
PRINT #1,

FOR I = 1 TO 16
  READ GWGT

    ' DIAWGT223  AREA x5.0
    ' DIAWGT20   AREA x4.0
    ' DIAWGT185  AREA x3.4, CLOSE TO OPTIMAL GAME WGT
    ' DIAWGT173  AREA x3.0, CLOSE TO OPTIMAL GAME WGT
    ' DIAWGT155  AREA x2.5
    ' DIAWGT1414 AREA x2.0
    ' DIAWGT122  AREA x1.5
    ' DIAWGT10   AREA x1.0

    ' DIAWGT = (DIA * EXPAN * 5.5) ^ 6:  REM AREA x3.0, CLOSE TO OPTIMAL WGT
    ' DIAWGT =  DIA^6 * EXPAN^6 * 5.5^6
    ' DIA2 = (GWGT / (EXPAN^6 * 5.5^6))^(1/6)

  DIA = (GWGT / (EXPAN ^ 6 * 5.5 ^ 6)) ^ (1 / 6)
  
  BW = 2867 * 4 * 3.141593 * (DIA / 2) ^ 3 / 3

  IF PRHYP$ = "R" OR PRHYP$ = "r" THEN
    BWGT = BW * 2.55 * BP
  ELSE
    BWGT = BW * 1.275 * BP
  END IF

  OGWB = VEL0 ^ 3 * BWGT ^ 2 * 1.5E-12

  PRINT USING "#.####"; DIA;
  PRINT ,
  PRINT USING "####.#"; BWGT;
  PRINT ,
  PRINT GWGT, TYP$(I),
  PRINT USING "#####"; OGWB

  PRINT #1, USING "#.####"; DIA;
  PRINT #1, ,
  PRINT #1, USING "####.#"; BWGT;
  PRINT #1, ,
  PRINT #1, GWGT, TYP$(I),
  PRINT #1, USING "#####"; OGWB


NEXT I
CLOSE #1
END

SUB GETNUM (PA)
  WHILE INKEY$ <> "": WEND
  PRINT " ["; PA; "] ";
  INPUT A$
  IF A$ = "" THEN GOTO SKIPS1
  PA = VAL(A$)
SKIPS1:
END SUB

SUB GETSTRG (PA$)
  WHILE INKEY$ <> "": WEND
  PRINT " [ "; PA$; " ] ";
  INPUT A$
  IF A$ = "" THEN GOTO SKIPS2
  PA$ = A$
SKIPS2:
END SUB

