DECLARE SUB GETNUM (PA!)
DECLARE SUB GETSTRG (PA$)

REM OPTIMUM GAME WEIGHT v1.23
REM 28 APRIL 2004
REM USING OPTIMUM GAME WEIGHT

REM VELOCITY DECREASES BELOW MIN BULLET DIA OF .224

REM [1A] OGWB = VEL ^ 3 * WGT ^ 2 * 1.5E-12
REM [1B]  WGT = (OGWB/(VEL^3*1.5E-12))^(1/2)
REM [1C]  VEL = (OGWB/(WGT^2*1.5E-12))^(1/3)
REM [2A]   BW = 2867 * 4 * 3.141593 * (DIA / 2) ^ 3 / 3   ' SPHERE
REM [2B]  DIA = (BW / (2867 * 4 * 3.141593 / 3)) ^ (1 / 3) * 2

DIM TYP$(16)
DATA 1A, 1B, 1C, 1D, 1E, 1F, 1G, 2L, 2, 2M, 3, 3D, 4, 4M, 4H, 5
FOR I = 1 TO 16
  READ TYP$(I)
NEXT I

DATA 0.78, 1.56, 3.125, 6.25, 12.5, 25, 50, 100, 200, 400, 800, 1600, 3200, 6400, 12800, 25600

BP = 1.35
VEL0 = 2300
PRHYP$ = "R"
DIAMIN = .224

CLS
PRINT " OPTIMUM GAME WEIGHT v1.23"
PRINT " 28 APRIL 2004"
PRINT " CALCULATES VALUES FOR *.CHK FILES, USING OPTIMUM GAME WEIGHT"

PRINT
PRINT "ENTER BULLET PROPORTION ";
CALL GETNUM(BP)
PRINT
PRINT "ENTER RIFLE/PISTOL (R/P)";
CALL GETSTRG(PRHYP$)
PRINT
PRINT "ENTER VELOCITY ";
CALL GETNUM(VEL0)
PRINT
PRINT "ENTER MINIMUM BULLET DIAMETER ";
CALL GETNUM(DIAMIN)
PRINT

PRINT "BULLET", "BULLET", "BULLET", "OPT GAME"
PRINT "DIA", "WEIGHT", "VEL", "WEIGHT"
PRINT "INCH", "GRAIN", "FPS", "LB"

OPEN "OGW.TXT" FOR OUTPUT AS #1

PRINT #1, "BULLET PROPORTION ="; BP;
IF PRHYP$ = "R" OR PRHYP$ = "r" THEN
  PRHYP2$ = "RIFLE"
ELSE
  PRHYP2$ = "PISTOL"
END IF
PRINT #1, ", "; PRHYP2$
PRINT #1,

FOR I = 1 TO 16
  READ OGWB
  VEL = VEL0
   
    ' BULLET, NOT A SPHERE
  BWGT = (OGWB / (VEL ^ 3 * 1.5E-12)) ^ (1 / 2)
   
  IF PRHYP$ = "R" OR PRHYP$ = "r" THEN
    BWS = BWGT / (2.55 * BP)   ' BWGT * 3 LOW
  ELSE
    BWS = BWGT / (1.275 * BP)  ' BWGT
  END IF
 
  DIA = (BWS / (2867 * 4 * 3.141593 / 3)) ^ (1 / 3) * 2

  IF DIA < DIAMIN THEN
    DIA = DIAMIN
    BWS = 2867 * 4 * 3.141593 * (DIA / 2) ^ 3 / 3   ' SPHERE
   
    IF PRHYP$ = "R" OR PRHYP$ = "r" THEN
      BWGT = BWS * 2.55 * BP
    ELSE
      BWGT = BWS * 1.275 * BP
    END IF
   
    VEL = (OGWB / (BWGT ^ 2 * 1.5E-12)) ^ (1 / 3)
  END IF

  PRINT USING "#.####"; DIA;
  PRINT ,
  PRINT USING "####.#"; BWGT;
  PRINT ,
  PRINT USING "####"; VEL;
  PRINT ,
  PRINT OGWB;
  PRINT ,
  PRINT TYP$(I)

  PRINT #1, USING "#.####"; DIA;
  PRINT #1, ,
  PRINT #1, USING "####.#"; BWGT;
  PRINT #1, ,
  PRINT #1, USING "####"; VEL;
  PRINT #1, ,
  PRINT #1, OGWB;
  PRINT #1, ,
  PRINT #1, TYP$(I)

NEXT I
CLOSE #1
END

    ' DIAWGT223  AREA x5.0
    ' DIAWGT20   AREA x4.0
    ' DIAWGT185  AREA x3.4, CLOSE TO OPTIMAL GAME WGT
    ' DIAWGT173  AREA x3.0, CLOSE TO OPTIMAL GAME WGT
    ' DIAWGT155  AREA x2.5
    ' DIAWGT1414 AREA x2.0
    ' DIAWGT122  AREA x1.5
    ' DIAWGT10   AREA x1.0
    ' DIAWGT = (DIA * EXPAN * 5.5) ^ 6:  REM AREA x3.0, CLOSE TO OPTIMAL WGT

SUB GETNUM (PA)
  WHILE INKEY$ <> "": WEND
  PRINT " ["; PA; "] ";
  INPUT A$
  IF A$ = "" THEN GOTO SKIPS1
  PA = VAL(A$)
SKIPS1:
END SUB

SUB GETSTRG (PA$)
  WHILE INKEY$ <> "": WEND
  PRINT " [ "; PA$; " ] ";
  INPUT A$
  IF A$ = "" THEN GOTO SKIPS2
  PA$ = A$
SKIPS2:
END SUB

